// Control.h : main header file for the CONTROL application
//

#if !defined(AFX_CONTROL_H__62B3A5A2_1A72_4250_AE33_88DFAEC82E3E__INCLUDED_)
#define AFX_CONTROL_H__62B3A5A2_1A72_4250_AE33_88DFAEC82E3E__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include "resource.h"       // main symbols
class CSlaveServer;
class CSequence;
class COutput;
class CSystemParamList;
class CSlaveIOList;
class CEasyDialog;
class CUtilityDialog;

extern CDialog* ActiveDialog;
extern bool HardwareAccess;

/////////////////////////////////////////////////////////////////////////////
// CControlApp:
// See Control.cpp for the implementation of this class
//
class CControlApp : public CWinApp
{
private:
	HANDLE Mutex;	
public:		
	void PauseSystemDuringMeasurment(CWnd* parent);
	void OnWakeUp();	
	CString ParamFileName;
	CControlApp();
	virtual ~CControlApp();
	void LoadParams(CFile &f);
	void SaveParams(CFile &f);
	void SaveParams(CString Name="");
	void LoadParams(CString Name="");
	void SaveParameterDialog();
	void LoadParameterDialog();
	void LoadReferenceParams(CString Name);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CControlApp)
	public:
	virtual BOOL InitInstance();
	virtual BOOL OnIdle(LONG lCount);
	//}}AFX_VIRTUAL

// Implementation
	//{{AFX_MSG(CControlApp)
	afx_msg void OnAppAbout();
		// NOTE - the ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};


extern CControlApp ControlApp;
extern CSlaveServer SlaveServer;
extern CSequence Sequence;
extern COutput* Output;
extern CSystemParamList SystemParamList;
extern CSlaveIOList SlaveIOList;
extern CUtilityDialog UtilityDialog;

extern void PumpMessages();

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CONTROL_H__62B3A5A2_1A72_4250_AE33_88DFAEC82E3E__INCLUDED_)
